--Configure OLE Automation object.
--EXECUTE permission set for object sp_OACreate
use [master]
GO
GRANT EXECUTE ON [sys].[sp_OASetProperty] TO [public]
GO
use [master]
GO
GRANT EXECUTE ON [sys].[sp_OAMethod] TO [public]
GO
use [master]
GO
GRANT EXECUTE ON [sys].[sp_OAGetErrorInfo] TO [public]
GO
use [master]
GO
GRANT EXECUTE ON [sys].[sp_OADestroy] TO [public]
GO
use [master]
GO
GRANT EXECUTE ON [sys].[sp_OAStop] TO [public]
GO
use [master]
GO
GRANT EXECUTE ON [sys].[sp_OACreate] TO [public]
GO
use [master]
GO
GRANT EXECUTE ON [sys].[sp_OAGetProperty] TO [public]
GO

--main_db
use [PPCSQL]
go

sp_configure 'show advanced options',1
GO
reconfigure
go

exec sp_configure 'Ole Automation Procedures',1
--Configuration option Ole Automation Procedures changed from 0 to 1. Run the RECONFIGURE statement to install.
go
reconfigure
go

IF OBJECT_ID (N'dbo.RegEx') IS NOT NULL
    DROP FUNCTION dbo.RegEx;
GO
create FUNCTION dbo.RegEx
    (
        --Expression Target / Source
        @Target varchar(5000),
        --Regular Expression Pattern
        @Pattern varchar(Max),
        --whether the expression case sensitive
        @CaseSensitive bit = 0
    )
RETURNS bit
AS
    BEGIN
        DECLARE @ReturnOACreate int
        DECLARE @ObjToken int
        DECLARE @objMatches int
        DECLARE @objMatch int
        DECLARE @count int
        DECLARE @results bit

        EXEC @ReturnOACreate = sp_OACreate 'VBScript.RegExp', @ObjToken OUTPUT

        --objecttoken OUTPUT
        --Is the returned object token, and must be a local variable of data type int.
        --This object token identifies the created OLE object and is used in calls to the other
        --OLE Automation stored procedures.
        --Return
        --0 (success) or a nonzero number (failure) that is the integer value of the
        --HRESULT returned by the OLE Automation object

        IF @ReturnOACreate <> 0 BEGIN
            SET @results = 0
            RETURN @results
        END

        EXEC @ReturnOACreate = sp_OASetProperty @ObjToken, 'Pattern', @Pattern

        IF @ReturnOACreate <> 0 BEGIN
            SET @results = 0
            RETURN @results
        END

        EXEC @ReturnOACreate = sp_OASetProperty @ObjToken, 'Global', false
        IF @ReturnOACreate <> 0 BEGIN
            SET @results = 0
            RETURN @results
        END

        EXEC @ReturnOACreate = sp_OASetProperty @ObjToken, 'IgnoreCase', @CaseSensitive
        IF @ReturnOACreate <> 0 BEGIN
            SET @results = 0
            RETURN @results
        END    

        EXEC @ReturnOACreate = sp_OAMethod @ObjToken, 'Test', @results OUTPUT, @Target
        IF @ReturnOACreate <> 0 BEGIN
            SET @results = 0
            RETURN @results
        END

        EXEC @ReturnOACreate = sp_OADestroy @ObjToken
        IF @ReturnOACreate <> 0 BEGIN
            SET @results = 0
            RETURN @results
        END
    --return 1 for success
    RETURN @results
    END;
go

if object_id(N'tempdb..#up', N'U') is not null
	drop table #up;
go
create table #up(
	id_user1 bigint,
	id_product1 bigint,
	id_product2 bigint,
	id_product3 bigint,
	user_fio1 varchar(200),
	year1 int,
	year2 int,
	year3 int,
	month1 int,
	month2 int,
	month3 int,
	money1 money,
	money2 money,
	money3 money,
	date1 varchar(20),
	date2 varchar(20),
	date3 varchar(20)
)

set dateformat dmy

declare @id_user1 bigint,@id_user2 bigint,@id_user3 bigint
declare @id_product1 bigint,@id_product2 bigint,@id_product3 bigint
declare @user_fio1 varchar(200),@user_fio2 varchar(200),@user_fio3 varchar(200)
declare @year1 int,@year2 int,@year3 int
declare @month1 int,@month2 int,@month3 int
declare @money1 money,@money2 money,@money3 money
declare @date1 varchar(20),@date2 varchar(20),@date3 varchar(20)

DECLARE up_cursor1 CURSOR FOR
select up.id_user,up.id_product,user_fio,year(date) as year,month(date) as month,money
,'01.'+(case len(cast(month(date) as varchar(2))) when 1 then '0'+cast(month(date) as varchar(2)) when 2 then cast(month(date) as varchar(2)) end)+'.'+cast(year(date) as varchar(4)) as date
from user_products up
join users u on u.id=up.id_user
join products p on p.id=up.id_product
where up.date>=u.bdate and up.date<=isnull(u.edate,'01.01.3000')
and up.date>=p.bdate and up.date<=isnull(p.edate,'01.01.3000')

OPEN up_cursor1

FETCH NEXT FROM up_cursor1 INTO @id_user1,@id_product1,@user_fio1,@year1,@month1,@money1,@date1

WHILE @@FETCH_STATUS = 0
BEGIN
	DECLARE up_cursor2 CURSOR FOR
	select up.id_user,up.id_product,user_fio,year(date) as year,month(date) as month,money
	,'01.'+(case len(cast(month(date) as varchar(2))) when 1 then '0'+cast(month(date) as varchar(2)) when 2 then cast(month(date) as varchar(2)) end)+'.'+cast(year(date) as varchar(4)) as date
	from user_products up
	join users u on u.id=up.id_user
	join products p on p.id=up.id_product
	where up.date>=u.bdate and up.date<=isnull(u.edate,'01.01.3000')
	and up.date>=p.bdate and up.date<=isnull(p.edate,'01.01.3000')

	OPEN up_cursor2

	FETCH NEXT FROM up_cursor2 INTO @id_user2,@id_product2,@user_fio2,@year2,@month2,@money2,@date2

	WHILE @@FETCH_STATUS = 0
	BEGIN
		DECLARE up_cursor3 CURSOR FOR
		select up.id_user,up.id_product,user_fio,year(date) as year,month(date) as month,money
		,'01.'+(case len(cast(month(date) as varchar(2))) when 1 then '0'+cast(month(date) as varchar(2)) when 2 then cast(month(date) as varchar(2)) end)+'.'+cast(year(date) as varchar(4)) as date
		from user_products up
		join users u on u.id=up.id_user
		join products p on p.id=up.id_product
		where up.date>=u.bdate and up.date<=isnull(u.edate,'01.01.3000')
		and up.date>=p.bdate and up.date<=isnull(p.edate,'01.01.3000')

		OPEN up_cursor3

		FETCH NEXT FROM up_cursor3 INTO @id_user3,@id_product3,@user_fio3,@year3,@month3,@money3,@date3

		WHILE @@FETCH_STATUS = 0
		BEGIN
			if @id_user1=@id_user2 and @id_user1=@id_user3 
				and cast(@date2 as datetime)=dateadd(month,1,cast(@date1 as datetime))
				and cast(@date3 as datetime)=dateadd(month,2,cast(@date1 as datetime))
			begin
				insert into #up
					select @id_user1,@id_product1,@id_product2,@id_product3,@user_fio1,@year1,@year2,@year3,
					@month1,@month2,@month3,@money1,@money2,@money3,
					cast(@date1 as datetime),cast(@date2 as datetime),cast(@date3 as datetime)
			end

			FETCH NEXT FROM up_cursor3 INTO @id_user3,@id_product3,@user_fio3,@year3,@month3,@money3,@date3
		END

		CLOSE up_cursor3
		DEALLOCATE up_cursor3

		FETCH NEXT FROM up_cursor2 INTO @id_user2,@id_product2,@user_fio2,@year2,@month2,@money2,@date2
	END

	CLOSE up_cursor2
	DEALLOCATE up_cursor2

	FETCH NEXT FROM up_cursor1 INTO @id_user1,@id_product1,@user_fio1,@year1,@month1,@money1,@date1
END

CLOSE up_cursor1
DEALLOCATE up_cursor1

declare @count bigint
set @count=0

DECLARE up_cursor CURSOR FOR
select user_fio1 from #up
group by user_fio1

OPEN up_cursor

declare @user_fio varchar(200)

FETCH NEXT FROM up_cursor INTO @user_fio

WHILE @@FETCH_STATUS = 0
BEGIN
	if dbo.RegEx(@user_fio, N'^[A-Z]{2,5}[^xyz]+(?=m|n|p)(?!a|b|c|d)[^r]+\.$',0 )=1
		set @count = @count + 1
	FETCH NEXT FROM up_cursor INTO @user_fio
END

CLOSE up_cursor
DEALLOCATE up_cursor

select @count as count
